#include "EasyTransfer.h"

//Captures address and size of struct
void EasyTransfer::init(uint8_t * ptr, uint8_t length){
address = ptr;
size = length;
}

//Sends out struct in binary, with header, length info and checksum
void EasyTransfer::sendData(){
  uint8_t CS = size;
  SERIALPORT.write(0x06);
  SERIALPORT.write(0x85);
  SERIALPORT.write(size);
  for(int i = 0; i<size; i++){
    CS^=*(address+i);
    SERIALPORT.write(*(address+i));
  }
  SERIALPORT.write(CS);

}

boolean EasyTransfer::receiveData(){
  
  if(rx_len == 0){
    if(SERIALPORT.available() >= 3){
      while(SERIALPORT.read() != 0x06) {}
      if (SERIALPORT.read() == 0x85){
        rx_len = SERIALPORT.read();
        if(rx_len != size){
          rx_len = 0;
          return false;
        }
      }
    }
  }
  
  
  if(rx_len != 0){
    while(SERIALPORT.available() && rx_array_inx <= rx_len){
      rx_array[rx_array_inx++] = SERIALPORT.read();
    }
    
    if(rx_len == (rx_array_inx-1)){
      //seem to have got whole message
      //last uint8_t is CS
      calc_CS = rx_len;
      for (int i = 0; i<rx_len; i++){
        calc_CS^=rx_array[i];
      } 
      
      if(calc_CS == rx_array[rx_array_inx-1]){//CS good
        memcpy(address,&rx_array,size);
		rx_len = 0;
		rx_array_inx = 0;
		return true;
		}
        
    }
  }
  
  return false;
}